# TDK-Lambda-server.py a server program for testing TDK-Lambda-client.py
import socket

HOST = ''                 # Symbolic name meaning all available interfaces
PORT = 50007              # Arbitrary non-privileged port
s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
print "Obtained a socket object s=",s
s.bind((HOST, PORT))
print "Bind s with host=",HOST," and port=",PORT
s.listen(1)
print "Established listen on s"
conn, addr = s.accept()
print 'Connected by', addr
dataCount=0
PSstate='OFF'	# assume PS is in OFF state
PSmode='CV'
LoadResistor=10.0
LoadResistor=25.0
Voltage=0.0
VoltageLimit=10.000
Current=0.0
CurrentLimit=1.000
while 1:
    print "Waiting for data to be retuned from 'conn.recv(1024)' call."
    data = conn.recv(1024)
    print "length of data is ",len(data)
    dataCount=dataCount+1
    if not data: break
    if data == '*IDN?' : data="fake TDK-Lambda"
    if data == 'output:state?' : data=PSstate
    if data == 'source:voltage?' : data=str(VoltageLimit)
    if data == 'source:current?' : data=str(CurrentLimit)
    if data == 'output:state ON' : 
        PSstate = 'ON'
        continue
    if data == 'source:mode?' : data=PSmode
    if data.split()[0] == ':voltage' :
        # set output voltage to arguement
        Voltage=float(data.split()[1])
        Current=Voltage/LoadResistor
	continue
    if data == 'measure:voltage?' :
        data = str(Voltage)
    if data == 'measure:current?' :
	data = str(Current)
    conn.send(data)

print "After test on 'not data' and break form while dataCount=",dataCount
conn.close()

